#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long n, o, a, b, ab;
    char s;
    long long O = 0, A = 0, B = 0;
    cin >> n;
    char y[n];
    long long x[n];
    static long long m[100000][4];
    cin >> o >> a >> b >> ab;
    for(int i = 0; i < n; i++)
    {
        cin >> y[i] >> x[i];
    }
    for(int i = 0; i < n; i++)
    {
        if (y[i] == 'O') O += x[i];
    }
    if (O > o)
    {
        cout << "nemoguce";
        return 0;
    }
    for (int i = 0; i < n; i++) if (y[i] == 'O') m[i][0]=x[i];
    o -= O;
    for(int i = 0; i < n; i++)
    {
        if (y[i] == 'A') A += x[i];
    }
    if (A > a + o)
    {
        cout << "nemoguce";
        return 0;
    }
    for (int i = 0; i < n; i++)
    {
        if (y[i] == 'A')
        {
            for (int j = 0; j < x[i]; j++)
            {
                if (a)
                {
                    a--;
                    m[i][1]++;
                }
                else
                {
                    o--;
                    m[i][0]++;
                }
            }
        }
    }
    for(int i = 0; i < n; i++)
    {
        if (y[i] == 'B') B += x[i];
    }
    if (B > b + o)
    {
        cout << "nemoguce";
        return 0;
    }
    for (int i = 0; i < n; i++)
    {
        if (y[i] == 'B')
        {
            for(int j = 0; j < x[i]; j++)
            {
                if (b)
                {
                    b--;
                    m[i][2]++;
                }
                else
                {
                    o--;
                    m[i][0]++;
                }
            }
        }
    }
    cout << "moguce" << endl;
    for(int i = 0; i < n; i++)
    {
        for (int j = 0; j < 4; j++) cout << m[i][j] << " ";
        cout << endl;
    }
    return 0;
}